	' Financial Functions
	' Created 11-3-1987 K. Murray
	'

	' Find the payments for borrowing an amount
	' with interest
' Interest#=Interest rate per period
' Period#=Period of payments
' Principal#=Amount of the load
Def Pmt1#(Interest#,Period#,Principal#)
  Pmt1#=Principal#*(Interest#/(1-(1/((1+Interest#)^Period#))))
End Def

	' Find the future value of a deposit with interest
	' compounded at any period
' Deposit#=Initial Deposit
' Interest#=Interest rate per period
' Period#=Period of deposit
Def Fv2#(Deposit#,Interest#,Period#)
	Fv2#=Deposit#*(1+Interest#)^Period#
End Def

	' Compute the present value with
	' future value, interest rate and period
' FutureV#=Future value required
' Interest#=Interest rate per period
' Period#=# of periods
Def Pv2#(FutureV#,Interest#,Period#)
	Pv2#=FutureV#*(1+Interest#)^-Period#
End Def

	' Compute the required interest
	' rate given the present value, future value
	' and period of time
' FutureV#=Future value
' PresentV#=Present value
' Period#=# of periods
Def Rate1#(FutureV#,PresentV#,Period#)
	Rate1#=(FutureV#^(1/Period#))/PresentV#^(1/Period#)-1
End Def
	
